# Summary

* [Go Patterns](/README.md)
  * [Creational Patterns](/README.md#creational-patterns)
    * [Abstract Factory](/creational/abstract_factory.md)
    * [Builder](/creational/builder.md)
    * [Factory Method](/creational/factory.md)
    * [Object Pool](/creational/object-pool.md)
    * [Singleton](/creational/singleton.md)
  * [Structural Patterns](/README.md#structural-patterns)
    * [Bridge](/structural/bridge.md)
    * [Composite](/structural/composite.md)
    * [Decorator](/structural/decorator.md)
    * [Facade](/structural/facade.md)
    * [Flyweight](/structural/flyweight.md)
    * [Proxy](/structural/proxy.md)
  * [Behavioral Patterns](/README.md#behavioral-patterns)
    * [Chain of Responsibility](/behavioral/chain_of_responsibility.md)
    * [Command](/behavioral/command.md)
    * [Mediator](/behavioral/mediator.md)
    * [Memento](/behavioral/memento.md)
    * [Observer](/behavioral/observer.md)
    * [Registry](/behavioral/registry.md)
    * [State](/behavioral/state.md)
    * [Strategy](/behavioral/strategy.md)
    * [Template](/behavioral/template.md)
    * [Visitor](/behavioral/visitor.md)
  * [Synchronization Patterns](/README.md#synchronization-patterns)
    * [Condition Variable](/synchronization/condition_variable.md)
    * [Lock/Mutex](/synchronization/mutex.md)
    * [Monitor](/synchronization/monitor.md)
    * [Read-Write Lock](/synchronization/read_write_lock.md)
    * [Semaphore](/synchronization/semaphore.md)
  * [Concurrency Patterns](/README.md#concurrency-patterns)
    * [N-Barrier](/concurrency/barrier.md)
    * [Bounded Parallelism](/concurrency/bounded_parallelism.md)
    * [Broadcast](/concurrency/broadcast.md)
    * [Coroutines](/concurrency/coroutine.md)
    * [Generators](/concurrency/generator.md)
    * [Reactor](/concurrency/reactor.md)
    * [Parallelism](/concurrency/parallelism.md)
    * [Producer Consumer](/concurrency/producer_consumer.md)
  * [Messaging Patterns](/README.md#messaging-patterns)
    * [Fan-In](/messaging/fan_in.md)
    * [Fan-Out](/messaging/fan_out.md)
    * [Futures & Promises](/messaging/futures_promises.md)
    * [Publish/Subscribe](/messaging/publish_subscribe.md)
    * [Push & Pull](/messaging/push_pull.md)
  * [Stability Patterns](/README.md#stability-patterns)
    * [Bulkheads](/stability/bulkhead.md)
    * [Circuit-Breaker](/stability/circuit-breaker.md)
    * [Deadline](/stability/deadline.md)
    * [Fail-Fast](/stability/fail_fast.md)
    * [Handshaking](/stability/handshaking.md)
    * [Steady-State](/stability/steady_state.md)
  * [Profiling Patterns](/README.md#profiling-patterns)
    * [Timing Functions](/profiling/timing.md)
  * [Idioms](/README.md#idioms)
    * [Functional Options](/idiom/functional-options.md)
  * [Anti-Patterns](/README.md#anti-patterns)
    * [Cascading Failures](/anti-patterns/cascading_failures.md)
* [Contributing](/CONTRIBUTING.md)
